import json
from tqdm import tqdm
import urllib3
from datetime import datetime as dt, timedelta, date
from dateutil.relativedelta import relativedelta
import pandas as pd
import numpy as np
import sqlalchemy
from sqlalchemy import create_engine
import time
from pathlib import Path

from data_loader import es_premium_df, role_ids, translate_freq, segments, schools_names, date_column, events, non_assistent_teachers

import dash
import dash_core_components as dcc
import dash_html_components as html
import plotly.express as px
from dash.dependencies import Input, Output

def to_input_item(compoment):
    return html.Div(
        className="padding-top-bot",
        children=[
            compoment
        ],
    )

# App Layout
def generate_layout(input_controls, chart_view):
    return html.Div(
        children=[
            # Error Message
            # html.Div(id="error-message"),
            # Top Banner
            html.Div(
                className="study-browser-banner row",
                children=[
                    html.H2(className="h2-title", children="Dados de engajamento de usuários", style={'textAlign': 'center', 'color': '#7FDBFF'}),
                ],
            ),
            # Body of the App
            html.Div(
                className="row app-body",
                children=[
                    # User Controls
                    html.Div(
                        className="four columns card",
                        style={'align': 'center'},
                        children=[
                            html.Div(
                                className="bg-white user-control",
                                children=list(map(to_input_item, input_controls)),
                            )
                        ],
                    ),
                    # Graph
                    html.Div(
                        className="eight columns card-left",
                        children=[
                            html.Div(
                                className="bg-white",
                                children=chart_view,
                            )
                        ],
                    ),
                    dcc.Store(id="error", storage_type="memory"),
                ],
            ),
        ]
    )
